#include <stdio.h>
#include <string.h>

int main()
{
	FILE *fz;
	int i, j;
	char name[64];
	unsigned char src[0x400], tmp[0x400];

	// Program Code
	unsigned char data[0x20] = {
		0x00, 0xFF, 0x60, 0x00, 0x62, 0x20, 0xA2, 0x20, 
		0x61, 0x00, 0xD1, 0x00, 0x71, 0x10, 0xF2, 0x1E, 
		0x31, 0x80, 0x12, 0x0A, 0x40, 0x30, 0x12, 0x16, 
		0x70, 0x10, 0x12, 0x08, 0x00, 0x00, 0x00, 0x00
	};

	printf ("Please type the file name of the monochrome (128x64) bitmap (BMP)\n");
	printf ("file you wish to use\n");
	gets (name);

	fz = fopen(name, "rb");
	if (fz == NULL)
	{
		printf ("%s not found\n");
		return 1;
	}

	fread (tmp, 1, 0x03e, fz);

	if (tmp[0x12] != 0x80 || tmp[0x16] != 0x40 || tmp[0x02] != 0x3e || tmp[0x1c] != 0x01 || tmp[0x03] != 0x04)
	{
		printf ("Not the proper format\n");
		return 1;
	}

	fread (tmp, 1, 0x400, fz);
	fclose (fz);

	for (i = 0; i < 0x400; i++)
	{
		j = (i & 0x301) | ((i >> 3) & 0x1e) | ((i & 0x0e) << 4);
		src[j ^ 0x31e] = tmp[i];
	}

	printf ("\nPlease type the output file name (Example \'name.sc\')\n");
	gets (name);
	if (strlen(name) == 0) return 0;

	fz = fopen(name, "wb");
	fwrite (data, 1, 0x20, fz);
	fwrite (src, 1, 0x400, fz);
	fclose (fz);
}
